cdac.medinfo.sdk.hl7282.baselibs.segments

## Class AIL

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.AIL

- All Implemented Interfaces:
    ISegment

      public class AIL
      extends Segment

  AIL - Appointment Information-Location Resource Segment.

  The AIL segment contains information about location resources (meeting rooms, operating rooms, examination rooms, or other locations) that can be scheduled.

  Represents an HL7 AIL message segment. This segment has the following fields:

  AIL-1: Set ID - AIL (SI)Required
  AIL-2: Segment Action Code (ID)Conditional
  AIL-3: Location Resource ID (PL)Conditional
  AIL-4: Location Type-AIL (CWE)Conditional
  AIL-5: Location Group (CWE)Optional
  AIL-6: Start Date/Time (DTM)Conditional
  AIL-7: Start Date/Time Offset (NM)Conditional
  AIL-8: Start Date/Time Offset Units (CNE)Conditional
  AIL-9: Duration (NM)Optional
  AIL-10: Duration Units (CNE)Optional
  AIL-11: Allow Substitution Code (CWE)Conditional
  AIL-12: Filler Status Code (CWE)Conditional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AIL()` Constructs the AIL segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addLocationResourceID(HD objPointOfCare, HD objRoom, HD objBed, HD objFacility, java.lang.String strLocationStatus, java.lang.String strPersonLocationType, HD objBuilding, HD objFloor, java.lang.String strLocationDescription, EI objComprehensiveLocationIdentifier, HD objAssigningAuthorityForLocation)` Add the Location Resource ID.
    `void` | `addLocationResourceID(PL objlocationResourceID)` Add the Location Resource ID.
    `CWE` | `getAllowSubstitutionCode()` Retrieves the Allow Substitution Code.
    `NM` | `getDuration()` Retrieves the Duration.
    `CNE` | `getDurationUnits()` Retrieves the Duration Units.
    `CWE` | `getFillerStatusCode()` Retrieves the Filler Status Code.
    `CWE` | `getLocationGroup()` Retrieves the Location Group.
    `ISingleCollection<PL>` | `getLocationResourceID()` Retrieves the Location Resource ID.
    `CWE` | `getLocationType_AIL()` Retrieves the Location Type AIL.
    `ID` | `getSegmentActionCode()` Retrieves the Segment Action Code.
    `SI` | `getSetID_AIL()` Retrieves the Set ID AIL.
    `DTM` | `getStartDateTime()` Retrieves the Start Date Time.
    `NM` | `getStartDateTimeOffset()` Retrieves the Start Date Time Offset.
    `CNE` | `getStartDateTimeOffsetUnits()` Retrieves the Start Date Time Offset Units.
    `void` | `setAllowSubstitutionCode(CWE objallowSubstitutionCode)` Set the Allow Substitution Code.
    `void` | `setAllowSubstitutionCode(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Allow Substitution Code.
    `void` | `setDuration(NM objduration)` Set the Duration.
    `void` | `setDuration(java.lang.String strDuration)` Set the Duration.
    `void` | `setDurationUnits(CNE objdurationUnits)` Set the Duration Units.
    `void` | `setDurationUnits(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Duration Units.
    `void` | `setFillerStatusCode(CWE objfillerStatusCode)` Set the Filler Status Code.
    `void` | `setFillerStatusCode(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Filler Status Code.
    `void` | `setLocationGroup(CWE objlocationGroup)` Set the Location Group.
    `void` | `setLocationGroup(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Location Group.
    `void` | `setLocationResourceID(ISingleCollection<PL> objlocationResourceIDList)` Set the Location Resource ID.
    `void` | `setLocationType_AIL(CWE objlocationType_AIL)` Set the Location Type AIL.
    `void` | `setLocationType_AIL(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Location Type AIL.
    `void` | `setSegmentActionCode(ID objsegmentActionCode)` Set the Segment Action Code.
    `void` | `setSegmentActionCode(java.lang.String strSegmentActionCode)` Set the Segment Action Code.
    `void` | `setSetID_AIL(SI objsetID_AIL)` Set the Set ID AIL.
    `void` | `setSetID_AIL(java.lang.String strSetID_AIL)` Set the Set ID AIL.
    `void` | `setStartDateTime(DTM objstartDateTime)` Set the Start Date Time.
    `void` | `setStartDateTime(java.lang.String strTime)` Set the Start Date Time.
    `void` | `setStartDateTimeOffset(NM objstartDateTimeOffset)` Set the Start Date Time Offset.
    `void` | `setStartDateTimeOffset(java.lang.String strStartDateTimeOffset)` Set the Start Date Time Offset.
    `void` | `setStartDateTimeOffsetUnits(CNE objstartDateTimeOffsetUnits)` Set the Start Date Time Offset Units.
    `void` | `setStartDateTimeOffsetUnits(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Start Date Time Offset Units.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AIL

          public AIL()

      Constructs the AIL segment.

  - ### Method Detail

    - #### getAllowSubstitutionCode

          public CWE getAllowSubstitutionCode()

      Retrieves the Allow Substitution Code. This field specify the code indicating whether the identified resource can be substituted with an equivalent resource by the filler application or not.
      Returns:
        CWE - allowSubstitutionCode

    - #### getDuration

          public NM getDuration()

      Retrieves the Duration. This field specify the duration for which the resource is requested/scheduled for this appointment, if different from the overall duration of the requested/scheduled appointment. expressed in units of time relative to the scheduled start date/time.
      Returns:
        NM - duration

    - #### getDurationUnits

          public CNE getDurationUnits()

      Retrieves the Duration Units. This field specify the units of time used for expressing the duration.
      Returns:
        CNE - durationUnits

    - #### getFillerStatusCode

          public CWE getFillerStatusCode()

      Retrieves the Filler Status Code. This field specify the code, that describes the requested/scheduled status of the resource or activity, from the point of view of the filler application.
      Returns:
        CWE - fillerStatusCode

    - #### getLocationGroup

          public CWE getLocationGroup()

      Retrieves the Location Group. This field specify the requested resource as a member of the indicated group.
      Returns:
        CWE - locationGroup

    - #### getLocationResourceID

          public ISingleCollection<PL> getLocationResourceID()

      Retrieves the Location Resource ID.
      Returns:
        ISingleCollection - locationResourceID

    - #### getLocationType_AIL

          public CWE getLocationType_AIL()

      Retrieves the Location Type AIL. This field specify the type of the location requested/scheduled for this appointment.
      Returns:
        CWE - locationType_AIL

    - #### getSegmentActionCode

          public ID getSegmentActionCode()

      Retrieves the Segment Action Code. This field specify the contains of the Action Code when updating or modifying information in this segment from previously sent interface transactions.
      Returns:
        ID - segmentActionCode

    - #### getSetID_AIL

          public SI getSetID_AIL()

      Retrieves the Set ID AIL.
      Returns:
        SI - setID_AIL

    - #### getStartDateTime

          public DTM getStartDateTime()

      Retrieves the Start Date Time. This field specify the date and time and this needs for the appointment.
      Returns:
        DTM - startDateTime

    - #### getStartDateTimeOffset

          public NM getStartDateTimeOffset()

      Retrieves the Start Date Time Offset. This field specify the offset and this needs for the appointment, expressed in units of time relative to the scheduled start date/time.
      Returns:
        NM - startDateTimeOffset

    - #### getStartDateTimeOffsetUnits

          public CNE getStartDateTimeOffsetUnits()

      Retrieves the Start Date Time Offset Units. This field specify the units of time used for expressing the start date/time offset.
      Returns:
        CNE - startDateTimeOffsetUnits

    - #### setSetID_AIL

          public void setSetID_AIL(java.lang.String strSetID_AIL)

      Set the Set ID AIL.
      Parameters:
        `strSetID_AIL` - This field contains the number that identifies AIL transaction.

    - #### setSetID_AIL

          public void setSetID_AIL(SI objsetID_AIL)

      Set the Set ID AIL.
      Parameters:
        `objsetID_AIL` - Object of Set ID AIL.

    - #### setSegmentActionCode

          public void setSegmentActionCode(java.lang.String strSegmentActionCode)

      Set the Segment Action Code. This field specify the contains of the Action Code when updating or modifying information in this segment from previously sent interface transactions.
      Parameters:
        `strSegmentActionCode` - String shows the action to be taken .

    - #### setSegmentActionCode

          public void setSegmentActionCode(ID objsegmentActionCode)

      Set the Segment Action Code. This field specify the contains of the Action Code when updating or modifying information in this segment from previously sent interface transactions.
      Parameters:
        `objsegmentActionCode` - Object of Segment Action Code.

    - #### addLocationResourceID

          public void addLocationResourceID(HD objPointOfCare,
                                   HD objRoom,
                                   HD objBed,
                                   HD objFacility,
                                   java.lang.String strLocationStatus,
                                   java.lang.String strPersonLocationType,
                                   HD objBuilding,
                                   HD objFloor,
                                   java.lang.String strLocationDescription,
                                   EI objComprehensiveLocationIdentifier,
                                   HD objAssigningAuthorityForLocation)

      Add the Location Resource ID.
      Parameters:
        `strPointOfCare` - Use as PointOfCare.
        `strRoom` - Use as Room.
        `strBed` - Use as Bed.
        `objFacility` - Use as Facility.
        `strLocationStatus` - Use as LocationStatus.
        `strPersonLocationType` - Use as PersonLocationType.
        `strBuilding` - Use as Building.
        `strFloor` - Use as Floor.
        `strLocationDescription` - Use as LocationDescription.
        `objComprehensiveLocationIdentifier` - Use as ComprehensiveLocationIdentifier.
        `objAssigningAuthorityForLocation` - Use as AssigningAuthorityForLocation.

    - #### addLocationResourceID

          public void addLocationResourceID(PL objlocationResourceID)

      Add the Location Resource ID.
      Parameters:
        `objlocationResourceID` - Object of Location Resource ID.

    - #### setLocationResourceID

          public void setLocationResourceID(ISingleCollection<PL> objlocationResourceIDList)

      Set the Location Resource ID.
      Parameters:
        `objlocationResourceIDList` - List of Location Resource ID.

    - #### setLocationType_AIL

          public void setLocationType_AIL(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Location Type AIL. This field specify the type of the location requested/scheduled for this appointment.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setLocationType_AIL

          public void setLocationType_AIL(CWE objlocationType_AIL)

      Set the Location Type AIL. This field specify the type of the location requested/scheduled for this appointment.
      Parameters:
        `objlocationType_AIL` - Object of Location Type AIL.

    - #### setLocationGroup

          public void setLocationGroup(java.lang.String strIdentifier,
                              java.lang.String strText,
                              java.lang.String strNameOfCodingSystem,
                              java.lang.String strAlternateIdentifier,
                              java.lang.String strAlternateText,
                              java.lang.String strNameOfAlternateCodingSystem,
                              java.lang.String strCodingSystemVersionID,
                              java.lang.String strAlternateCodingSystemVersionId,
                              java.lang.String strOriginalText,
                              java.lang.String strSecondAlternateIdentifier,
                              java.lang.String strSecondAlternateText,
                              java.lang.String strNameofSecondAlternateCodingSystem,
                              java.lang.String strSecondAlternateCodingSystemVersionID,
                              java.lang.String strCodingSystemOID,
                              java.lang.String strValueSetOID,
                              java.lang.String strValueSetVersionID,
                              java.lang.String strAlternateCodingSystemOID,
                              java.lang.String strAlternateValueSetOID,
                              java.lang.String strAlternateValueSetVersionID,
                              java.lang.String strSecondAlternateCodingSystemOID,
                              java.lang.String strSecondAlternateValueSetOID,
                              java.lang.String strSecondAlternateValueSetVersionID)

      Set the Location Group. This field specify the requested resource as a member of the indicated group.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setLocationGroup

          public void setLocationGroup(CWE objlocationGroup)

      Set the Location Group. This field specify the requested resource as a member of the indicated group.
      Parameters:
        `objlocationGroup` - Object of Location Group.

    - #### setStartDateTime

          public void setStartDateTime(java.lang.String strTime)

      Set the Start Date Time. This field specify the date and time and this needs for the appointment.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setStartDateTime

          public void setStartDateTime(DTM objstartDateTime)

      Set the Start Date Time. This field specify the date and time and this needs for the appointment.
      Parameters:
        `objstartDateTime` - Object of Start Date Time.

    - #### setStartDateTimeOffset

          public void setStartDateTimeOffset(java.lang.String strStartDateTimeOffset)

      Set the Start Date Time Offset. This field specify the offset and this needs for the appointment, expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `strStartDateTimeOffset` - Amount of time being requested for the appointment. .

    - #### setStartDateTimeOffset

          public void setStartDateTimeOffset(NM objstartDateTimeOffset)

      Set the Start Date Time Offset. This field specify the offset and this needs for the appointment, expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `objstartDateTimeOffset` - Object of Start Date Time Offset.

    - #### setStartDateTimeOffsetUnits

          public void setStartDateTimeOffsetUnits(java.lang.String strIdentifier,
                                         java.lang.String strText,
                                         java.lang.String strNameOfCodingSystem,
                                         java.lang.String strAlternateIdentifier,
                                         java.lang.String strAlternateText,
                                         java.lang.String strNameOfAlternateCodingSystem,
                                         java.lang.String strCodingSystemVersionID,
                                         java.lang.String strAlternateCodingSystemVersionID,
                                         java.lang.String strOriginalText,
                                         java.lang.String strSecondAlternateIdentifier,
                                         java.lang.String strSecondAlternateText,
                                         java.lang.String strNameOfSecondAltenateCodingSystem,
                                         java.lang.String strSecondAlternateCodingSystemVersionID,
                                         java.lang.String strCodingSystemOID,
                                         java.lang.String strValueSetOID,
                                         java.lang.String strValueSetVersionID,
                                         java.lang.String strAlternateCodingSystemOID,
                                         java.lang.String strAlternateValueSetOID,
                                         java.lang.String strAlternateValueSetVersionID,
                                         java.lang.String strSecondAlternateCodingSystemOID,
                                         java.lang.String strSecondAlternateValueSetOID,
                                         java.lang.String strSecondAlternateValueSetVersionID)

      Set the Start Date Time Offset Units. This field specify the units of time used for expressing the start date/time offset.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setStartDateTimeOffsetUnits

          public void setStartDateTimeOffsetUnits(CNE objstartDateTimeOffsetUnits)

      Set the Start Date Time Offset Units. This field specify the units of time used for expressing the start date/time offset.
      Parameters:
        `objstartDateTimeOffsetUnits` - Object of Start Date Time Offset Units.

    - #### setDuration

          public void setDuration(java.lang.String strDuration)

      Set the Duration. This field specify the duration for which the resource is requested/scheduled for this appointment, if different from the overall duration of the requested/scheduled appointment. expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `strDuration` - Amount of time being requested for the appointment. .

    - #### setDuration

          public void setDuration(NM objduration)

      Set the Duration. This field specify the duration for which the resource is requested/scheduled for this appointment, if different from the overall duration of the requested/scheduled appointment. expressed in units of time relative to the scheduled start date/time.
      Parameters:
        `objduration` - Object of Duration.

    - #### setDurationUnits

          public void setDurationUnits(java.lang.String strIdentifier,
                              java.lang.String strText,
                              java.lang.String strNameOfCodingSystem,
                              java.lang.String strAlternateIdentifier,
                              java.lang.String strAlternateText,
                              java.lang.String strNameOfAlternateCodingSystem,
                              java.lang.String strCodingSystemVersionID,
                              java.lang.String strAlternateCodingSystemVersionID,
                              java.lang.String strOriginalText,
                              java.lang.String strSecondAlternateIdentifier,
                              java.lang.String strSecondAlternateText,
                              java.lang.String strNameOfSecondAltenateCodingSystem,
                              java.lang.String strSecondAlternateCodingSystemVersionID,
                              java.lang.String strCodingSystemOID,
                              java.lang.String strValueSetOID,
                              java.lang.String strValueSetVersionID,
                              java.lang.String strAlternateCodingSystemOID,
                              java.lang.String strAlternateValueSetOID,
                              java.lang.String strAlternateValueSetVersionID,
                              java.lang.String strSecondAlternateCodingSystemOID,
                              java.lang.String strSecondAlternateValueSetOID,
                              java.lang.String strSecondAlternateValueSetVersionID)

      Set the Duration Units. This field specify the units of time used for expressing the duration.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setDurationUnits

          public void setDurationUnits(CNE objdurationUnits)

      Set the Duration Units. This field specify the units of time used for expressing the duration.
      Parameters:
        `objdurationUnits` - Object of Duration Units.

    - #### setAllowSubstitutionCode

          public void setAllowSubstitutionCode(java.lang.String strIdentifier,
                                      java.lang.String strText,
                                      java.lang.String strNameOfCodingSystem,
                                      java.lang.String strAlternateIdentifier,
                                      java.lang.String strAlternateText,
                                      java.lang.String strNameOfAlternateCodingSystem,
                                      java.lang.String strCodingSystemVersionID,
                                      java.lang.String strAlternateCodingSystemVersionId,
                                      java.lang.String strOriginalText,
                                      java.lang.String strSecondAlternateIdentifier,
                                      java.lang.String strSecondAlternateText,
                                      java.lang.String strNameofSecondAlternateCodingSystem,
                                      java.lang.String strSecondAlternateCodingSystemVersionID,
                                      java.lang.String strCodingSystemOID,
                                      java.lang.String strValueSetOID,
                                      java.lang.String strValueSetVersionID,
                                      java.lang.String strAlternateCodingSystemOID,
                                      java.lang.String strAlternateValueSetOID,
                                      java.lang.String strAlternateValueSetVersionID,
                                      java.lang.String strSecondAlternateCodingSystemOID,
                                      java.lang.String strSecondAlternateValueSetOID,
                                      java.lang.String strSecondAlternateValueSetVersionID)

      Set the Allow Substitution Code. This field specify the code indicating whether the identified resource can be substituted with an equivalent resource by the filler application or not.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setAllowSubstitutionCode

          public void setAllowSubstitutionCode(CWE objallowSubstitutionCode)

      Set the Allow Substitution Code. This field specify the code indicating whether the identified resource can be substituted with an equivalent resource by the filler application or not.
      Parameters:
        `objallowSubstitutionCode` - Object of Allow Substitution Code.

    - #### setFillerStatusCode

          public void setFillerStatusCode(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Filler Status Code. This field specify the code, that describes the requested/scheduled status of the resource or activity, from the point of view of the filler application.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setFillerStatusCode

          public void setFillerStatusCode(CWE objfillerStatusCode)

      Set the Filler Status Code. This field specify the code, that describes the requested/scheduled status of the resource or activity, from the point of view of the filler application.
      Parameters:
        `objfillerStatusCode` - Object of Filler Status Code.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - If Segment Validation fails.